;---------------------------------------------------------------------------------------------------------------
; Test code for binary to ASCIIZ conversion routines
xtoa_test:

.equ    unsigned24 = 15999999   ; unsigned 24-bit test number, 0..16777215 range
.equ    unsigned16 = 64999      ; unsigned 16-bit test number, 0..65535 range
.equ    signed16 = 31999        ; signed 16-bit test number, 0..32767 range

                ldiw    y,binbuf                ; Y points to an input binary MSB
                ldiw    z,ascbuf                ; Z points to an output ASCIIZ string start

		ldi	wreg,byte3(unsigned24)	; 24-bit binary MSB
                std     y+0,wreg
		ldi	wreg,byte2(unsigned24)	; 24-bit binary 2SB
                std     y+1,wreg
		ldi	wreg,byte1(unsigned24)	; 24-bit binary LSB
                std     y+2,wreg
		ldi	wreg,4                  ; Decimal point (DP) position
		rcall	u24toap 		; Test an unsigned 24-bit conversion

		ldi	wreg,high(unsigned16)	; 16-bit binary MSB
                std     y+0,wreg
		ldi	wreg,low(unsigned16)	; 16-bit binary LSB
                std     y+1,wreg
		ldi	wreg,3                  ; Decimal point (DP) position
		rcall	uitoap	        	; Test an unsigned 16-bit conversion

		ldi	wreg,high(signed16)	; 16-bit binary MSB
                std     y+0,wreg
		ldi	wreg,low(signed16)	; 16-bit binary LSB
                std     y+1,wreg
		ldi	wreg,2                  ; Decimal point (DP) position
		rcall	sitoap	        	; Test a signed 16-bit conversion with positive value

		ldi	wreg,high(-signed16)	; 16-bit binary MSB
                std     y+0,wreg
		ldi	wreg,low(-signed16)	; 16-bit binary LSB
                std     y+1,wreg
		ldi	wreg,1                  ; Decimal point (DP) position
		rcall	sitoap	        	; Test a signed 16-bit conversion with negative value

		rjmp    xtoa_test               ; Loop
;---------------------------------------------------------------------------------------------------------------

